
@@ Syscalls definitions, taken from asm/unistd.h

.equ __NR_SYSCALL_BASE,		0x900000

.equ __NR_exit,			(__NR_SYSCALL_BASE+  1)
.equ __NR_fork,			(__NR_SYSCALL_BASE+  2)
.equ __NR_read,			(__NR_SYSCALL_BASE+  3)
.equ __NR_write,		(__NR_SYSCALL_BASE+  4)
.equ __NR_open,			(__NR_SYSCALL_BASE+  5)
.equ __NR_close,		(__NR_SYSCALL_BASE+  6)
.equ __NR_waitpid,		(__NR_SYSCALL_BASE+  7)
.equ __NR_creat,		(__NR_SYSCALL_BASE+  8)
.equ __NR_link,			(__NR_SYSCALL_BASE+  9)
.equ __NR_unlink,		(__NR_SYSCALL_BASE+ 10)
.equ __NR_execve,		(__NR_SYSCALL_BASE+ 11)
.equ __NR_chdir,		(__NR_SYSCALL_BASE+ 12)
.equ __NR_time,			(__NR_SYSCALL_BASE+ 13)
.equ __NR_mknod,		(__NR_SYSCALL_BASE+ 14)
.equ __NR_chmod,		(__NR_SYSCALL_BASE+ 15)
.equ __NR_lchown,		(__NR_SYSCALL_BASE+ 16)
.equ __NR_break,		(__NR_SYSCALL_BASE+ 17)

.equ __NR_lseek,		(__NR_SYSCALL_BASE+ 19)
.equ __NR_getpid,		(__NR_SYSCALL_BASE+ 20)
.equ __NR_mount,		(__NR_SYSCALL_BASE+ 21)
.equ __NR_umount,		(__NR_SYSCALL_BASE+ 22)
.equ __NR_setuid,		(__NR_SYSCALL_BASE+ 23)
.equ __NR_getuid,		(__NR_SYSCALL_BASE+ 24)
.equ __NR_stime,		(__NR_SYSCALL_BASE+ 25)
.equ __NR_ptrace,		(__NR_SYSCALL_BASE+ 26)
.equ __NR_alarm,		(__NR_SYSCALL_BASE+ 27)

.equ __NR_pause,                      (__NR_SYSCALL_BASE+ 29)
.equ __NR_utime,                      (__NR_SYSCALL_BASE+ 30)
.equ __NR_stty,                       (__NR_SYSCALL_BASE+ 31)
.equ __NR_gtty,                       (__NR_SYSCALL_BASE+ 32)
.equ __NR_access,                     (__NR_SYSCALL_BASE+ 33)
.equ __NR_nice,                       (__NR_SYSCALL_BASE+ 34)
.equ __NR_ftime,                      (__NR_SYSCALL_BASE+ 35)
.equ __NR_sync,                       (__NR_SYSCALL_BASE+ 36)
.equ __NR_kill,                       (__NR_SYSCALL_BASE+ 37)
.equ __NR_rename,                     (__NR_SYSCALL_BASE+ 38)
.equ __NR_mkdir,                      (__NR_SYSCALL_BASE+ 39)
.equ __NR_rmdir,                      (__NR_SYSCALL_BASE+ 40)
.equ __NR_dup,                        (__NR_SYSCALL_BASE+ 41)
.equ __NR_pipe,                       (__NR_SYSCALL_BASE+ 42)
.equ __NR_times,                      (__NR_SYSCALL_BASE+ 43)
.equ __NR_prof,                       (__NR_SYSCALL_BASE+ 44)
.equ __NR_brk,                        (__NR_SYSCALL_BASE+ 45)
.equ __NR_setgid,                     (__NR_SYSCALL_BASE+ 46)
.equ __NR_getgid,                     (__NR_SYSCALL_BASE+ 47)
.equ __NR_signal,                     (__NR_SYSCALL_BASE+ 48)
.equ __NR_geteuid,                    (__NR_SYSCALL_BASE+ 49)
.equ __NR_getegid,                    (__NR_SYSCALL_BASE+ 50)
.equ __NR_acct,                       (__NR_SYSCALL_BASE+ 51)
.equ __NR_umount2,                    (__NR_SYSCALL_BASE+ 52)
.equ __NR_lock,                       (__NR_SYSCALL_BASE+ 53)
.equ __NR_ioctl,                      (__NR_SYSCALL_BASE+ 54)
.equ __NR_fcntl,                      (__NR_SYSCALL_BASE+ 55)
.equ __NR_mpx,                        (__NR_SYSCALL_BASE+ 56)
.equ __NR_setpgid,                    (__NR_SYSCALL_BASE+ 57)
.equ __NR_ulimit,                     (__NR_SYSCALL_BASE+ 58)

.equ __NR_umask,                      (__NR_SYSCALL_BASE+ 60)
.equ __NR_chroot,                     (__NR_SYSCALL_BASE+ 61)
.equ __NR_ustat,                      (__NR_SYSCALL_BASE+ 62)
.equ __NR_dup2,                       (__NR_SYSCALL_BASE+ 63)
.equ __NR_getppid,                    (__NR_SYSCALL_BASE+ 64)
.equ __NR_getpgrp,                    (__NR_SYSCALL_BASE+ 65)
.equ __NR_setsid,                     (__NR_SYSCALL_BASE+ 66)
.equ __NR_sigaction,                  (__NR_SYSCALL_BASE+ 67)
.equ __NR_sgetmask,                   (__NR_SYSCALL_BASE+ 68)
.equ __NR_ssetmask,                   (__NR_SYSCALL_BASE+ 69)
.equ __NR_setreuid,                   (__NR_SYSCALL_BASE+ 70)
.equ __NR_setregid,                   (__NR_SYSCALL_BASE+ 71)
.equ __NR_sigsuspend,                 (__NR_SYSCALL_BASE+ 72)
.equ __NR_sigpending,                 (__NR_SYSCALL_BASE+ 73)
.equ __NR_sethostname,                (__NR_SYSCALL_BASE+ 74)
.equ __NR_setrlimit,                  (__NR_SYSCALL_BASE+ 75)
.equ __NR_getrlimit,                  (__NR_SYSCALL_BASE+ 76) /* Back compat 2GB limited rlimit */
.equ __NR_getrusage,                  (__NR_SYSCALL_BASE+ 77)
.equ __NR_gettimeofday,               (__NR_SYSCALL_BASE+ 78)
.equ __NR_settimeofday,               (__NR_SYSCALL_BASE+ 79)
.equ __NR_getgroups,                  (__NR_SYSCALL_BASE+ 80)
.equ __NR_setgroups,                  (__NR_SYSCALL_BASE+ 81)
.equ __NR_select,                     (__NR_SYSCALL_BASE+ 82)
.equ __NR_symlink,                    (__NR_SYSCALL_BASE+ 83)

.equ __NR_readlink,                   (__NR_SYSCALL_BASE+ 85)
.equ __NR_uselib,                     (__NR_SYSCALL_BASE+ 86)
.equ __NR_swapon,                     (__NR_SYSCALL_BASE+ 87)
.equ __NR_reboot,                     (__NR_SYSCALL_BASE+ 88)
.equ __NR_readdir,                    (__NR_SYSCALL_BASE+ 89)
.equ __NR_mmap,                       (__NR_SYSCALL_BASE+ 90)
.equ __NR_munmap,                     (__NR_SYSCALL_BASE+ 91)
.equ __NR_truncate,                   (__NR_SYSCALL_BASE+ 92)
.equ __NR_ftruncate,                  (__NR_SYSCALL_BASE+ 93)
.equ __NR_fchmod,                     (__NR_SYSCALL_BASE+ 94)
.equ __NR_fchown,                     (__NR_SYSCALL_BASE+ 95)
.equ __NR_getpriority,                (__NR_SYSCALL_BASE+ 96)
.equ __NR_setpriority,                (__NR_SYSCALL_BASE+ 97)
.equ __NR_profil,                     (__NR_SYSCALL_BASE+ 98)
.equ __NR_statfs,                     (__NR_SYSCALL_BASE+ 99)
.equ __NR_fstatfs,                    (__NR_SYSCALL_BASE+100)
.equ __NR_ioperm,                     (__NR_SYSCALL_BASE+101)
.equ __NR_socketcall,                 (__NR_SYSCALL_BASE+102)
.equ __NR_syslog,                     (__NR_SYSCALL_BASE+103)
.equ __NR_setitimer,                  (__NR_SYSCALL_BASE+104)
.equ __NR_getitimer,                  (__NR_SYSCALL_BASE+105)
.equ __NR_stat,                       (__NR_SYSCALL_BASE+106)
.equ __NR_lstat,                      (__NR_SYSCALL_BASE+107)
.equ __NR_fstat,                      (__NR_SYSCALL_BASE+108)


.equ __NR_vhangup,                    (__NR_SYSCALL_BASE+111)
.equ __NR_idle,                       (__NR_SYSCALL_BASE+112)
.equ __NR_syscall,                    (__NR_SYSCALL_BASE+113) /* syscall to call a syscall! */
.equ __NR_wait4,                      (__NR_SYSCALL_BASE+114)
.equ __NR_swapoff,                    (__NR_SYSCALL_BASE+115)
.equ __NR_sysinfo,                    (__NR_SYSCALL_BASE+116)
.equ __NR_ipc,                        (__NR_SYSCALL_BASE+117)
.equ __NR_fsync,                      (__NR_SYSCALL_BASE+118)
.equ __NR_sigreturn,                  (__NR_SYSCALL_BASE+119)
.equ __NR_clone,                      (__NR_SYSCALL_BASE+120)
.equ __NR_setdomainname,              (__NR_SYSCALL_BASE+121)
.equ __NR_uname,                      (__NR_SYSCALL_BASE+122)
.equ __NR_modify_ldt,                 (__NR_SYSCALL_BASE+123)
.equ __NR_adjtimex,                   (__NR_SYSCALL_BASE+124)
.equ __NR_mprotect,                   (__NR_SYSCALL_BASE+125)
.equ __NR_sigprocmask,                (__NR_SYSCALL_BASE+126)
.equ __NR_create_module,              (__NR_SYSCALL_BASE+127)
.equ __NR_init_module,                (__NR_SYSCALL_BASE+128)
.equ __NR_delete_module,              (__NR_SYSCALL_BASE+129)
.equ __NR_get_kernel_syms,            (__NR_SYSCALL_BASE+130)
.equ __NR_quotactl,                   (__NR_SYSCALL_BASE+131)
.equ __NR_getpgid,                    (__NR_SYSCALL_BASE+132)
.equ __NR_fchdir,                     (__NR_SYSCALL_BASE+133)
.equ __NR_bdflush,                    (__NR_SYSCALL_BASE+134)
.equ __NR_sysfs,                      (__NR_SYSCALL_BASE+135)
.equ __NR_personality,                (__NR_SYSCALL_BASE+136)
.equ __NR_afs_syscall,                (__NR_SYSCALL_BASE+137) /* Syscall for Andrew File System */
.equ __NR_setfsuid,                   (__NR_SYSCALL_BASE+138)
.equ __NR_setfsgid,                   (__NR_SYSCALL_BASE+139)
.equ __NR__llseek,                    (__NR_SYSCALL_BASE+140)
.equ __NR_getdents,                   (__NR_SYSCALL_BASE+141)
.equ __NR__newselect,                 (__NR_SYSCALL_BASE+142)
.equ __NR_flock,                      (__NR_SYSCALL_BASE+143)
.equ __NR_msync,                      (__NR_SYSCALL_BASE+144)
.equ __NR_readv,                      (__NR_SYSCALL_BASE+145)
.equ __NR_writev,                     (__NR_SYSCALL_BASE+146)
.equ __NR_getsid,                     (__NR_SYSCALL_BASE+147)
.equ __NR_fdatasync,                  (__NR_SYSCALL_BASE+148)
.equ __NR__sysctl,                    (__NR_SYSCALL_BASE+149)
.equ __NR_mlock,                      (__NR_SYSCALL_BASE+150)
.equ __NR_munlock,                    (__NR_SYSCALL_BASE+151)
.equ __NR_mlockall,                   (__NR_SYSCALL_BASE+152)
.equ __NR_munlockall,                 (__NR_SYSCALL_BASE+153)
.equ __NR_sched_setparam,             (__NR_SYSCALL_BASE+154)
.equ __NR_sched_getparam,             (__NR_SYSCALL_BASE+155)
.equ __NR_sched_setscheduler,         (__NR_SYSCALL_BASE+156)
.equ __NR_sched_getscheduler,         (__NR_SYSCALL_BASE+157)
.equ __NR_sched_yield,                (__NR_SYSCALL_BASE+158)
.equ __NR_sched_get_priority_max,     (__NR_SYSCALL_BASE+159)
.equ __NR_sched_get_priority_min,     (__NR_SYSCALL_BASE+160)
.equ __NR_sched_rr_get_interval,      (__NR_SYSCALL_BASE+161)
.equ __NR_nanosleep,                  (__NR_SYSCALL_BASE+162)
.equ __NR_mremap,                     (__NR_SYSCALL_BASE+163)
.equ __NR_setresuid,                  (__NR_SYSCALL_BASE+164)
.equ __NR_getresuid,                  (__NR_SYSCALL_BASE+165)
.equ __NR_vm86,                       (__NR_SYSCALL_BASE+166)
.equ __NR_query_module,               (__NR_SYSCALL_BASE+167)
.equ __NR_poll,                       (__NR_SYSCALL_BASE+168)
.equ __NR_nfsservctl,                 (__NR_SYSCALL_BASE+169)
.equ __NR_setresgid,                  (__NR_SYSCALL_BASE+170)
.equ __NR_getresgid,                  (__NR_SYSCALL_BASE+171)
.equ __NR_prctl,                      (__NR_SYSCALL_BASE+172)
.equ __NR_rt_sigreturn,               (__NR_SYSCALL_BASE+173)
.equ __NR_rt_sigaction,               (__NR_SYSCALL_BASE+174)
.equ __NR_rt_sigprocmask,             (__NR_SYSCALL_BASE+175)
.equ __NR_rt_sigpending,              (__NR_SYSCALL_BASE+176)
.equ __NR_rt_sigtimedwait,            (__NR_SYSCALL_BASE+177)
.equ __NR_rt_sigqueueinfo,            (__NR_SYSCALL_BASE+178)
.equ __NR_rt_sigsuspend,              (__NR_SYSCALL_BASE+179)
.equ __NR_pread,                      (__NR_SYSCALL_BASE+180)
.equ __NR_pwrite,                     (__NR_SYSCALL_BASE+181)
.equ __NR_chown,                      (__NR_SYSCALL_BASE+182)
.equ __NR_getcwd,                     (__NR_SYSCALL_BASE+183)
.equ __NR_capget,                     (__NR_SYSCALL_BASE+184)
.equ __NR_capset,                     (__NR_SYSCALL_BASE+185)
.equ __NR_sigaltstack,                (__NR_SYSCALL_BASE+186)
.equ __NR_sendfile,                   (__NR_SYSCALL_BASE+187)
                                        /* 188 reserved */
                                        /* 189 reserved */
.equ __NR_vfork,                      (__NR_SYSCALL_BASE+190)
.equ __NR_ugetrlimit,                 (__NR_SYSCALL_BASE+191) /* SuS compliant getrlimit */
.equ __NR_mmap2,                      (__NR_SYSCALL_BASE+192)
.equ __NR_truncate64,                 (__NR_SYSCALL_BASE+193)
.equ __NR_ftruncate64,                (__NR_SYSCALL_BASE+194)
.equ __NR_stat64,                     (__NR_SYSCALL_BASE+195)
.equ __NR_lstat64,                    (__NR_SYSCALL_BASE+196)
.equ __NR_fstat64,                    (__NR_SYSCALL_BASE+197)
.equ __NR_lchown32,                   (__NR_SYSCALL_BASE+198)
.equ __NR_getuid32,                   (__NR_SYSCALL_BASE+199)
.equ __NR_getgid32,                   (__NR_SYSCALL_BASE+200)
.equ __NR_geteuid32,                  (__NR_SYSCALL_BASE+201)
.equ __NR_getegid32,                  (__NR_SYSCALL_BASE+202)
.equ __NR_setreuid32,                 (__NR_SYSCALL_BASE+203)
.equ __NR_setregid32,                 (__NR_SYSCALL_BASE+204)
.equ __NR_getgroups32,                (__NR_SYSCALL_BASE+205)
.equ __NR_setgroups32,                (__NR_SYSCALL_BASE+206)
.equ __NR_fchown32,                   (__NR_SYSCALL_BASE+207)
.equ __NR_setresuid32,                (__NR_SYSCALL_BASE+208)
.equ __NR_getresuid32,                (__NR_SYSCALL_BASE+209)
.equ __NR_setresgid32,                (__NR_SYSCALL_BASE+210)
.equ __NR_getresgid32,                (__NR_SYSCALL_BASE+211)
.equ __NR_chown32,                    (__NR_SYSCALL_BASE+212)
.equ __NR_setuid32,                   (__NR_SYSCALL_BASE+213)
.equ __NR_setgid32,                   (__NR_SYSCALL_BASE+214)
.equ __NR_setfsuid32,                 (__NR_SYSCALL_BASE+215)
.equ __NR_setfsgid32,                 (__NR_SYSCALL_BASE+216)
.equ __NR_getdents64,                 (__NR_SYSCALL_BASE+217)
.equ __NR_pivot_root,                 (__NR_SYSCALL_BASE+218)
.equ __NR_mincore,                    (__NR_SYSCALL_BASE+219)
.equ __NR_madvise,                    (__NR_SYSCALL_BASE+220)
.equ __NR_fcntl64,                    (__NR_SYSCALL_BASE+221)


.macro	sys_exit
	swi	__NR_exit
.endm

.macro	sys_fork
	swi	__NR_fork
.endm

.macro	sys_read	a1, a2, a3
	mov	r0,\a1
	mov	r1,\a2
	mov	r2,\a3
	swi	__NR_read
.endm

.macro  _sys_read
	swi	__NR_read
.endm

.macro	sys_write	a1, a2, a3
	mov	r0,\a1
	mov	r1,\a2
	mov	r2,\a3
	swi	__NR_write
.endm

.macro	_sys_write
	swi	__NR_write
.endm

.macro	sys_open	a1,a2
	mov	r0,\a1
	mov	r1,\a2
	swi	__NR_open
.endm

.macro	_sys_open
	swi	__NR_open
.endm

.macro	sys_close	a1
	mov	r0,\a1
	swi	__NR_close
.endm

.macro	_sys_close
	swi	__NR_close
.endm

.macro	sys_socketcall	a1,a2
	mov	r0,\a1
	mov	r1,\a2
	swi	__NR_socketcall
.endm

.macro	_sys_socketcall
	swi	__NR_socketcall
.endm

@
@ socketcall codes from linux/net.h
@
.equ SYS_SOCKET,      1               /* sys_socket(2)                */
.equ SYS_BIND,        2               /* sys_bind(2)                  */
.equ SYS_CONNECT,     3               /* sys_connect(2)               */
.equ SYS_LISTEN,      4               /* sys_listen(2)                */
.equ SYS_ACCEPT,      5               /* sys_accept(2)                */
.equ SYS_GETSOCKNAME, 6               /* sys_getsockname(2)           */
.equ SYS_GETPEERNAME, 7               /* sys_getpeername(2)           */
.equ SYS_SOCKETPAIR,  8               /* sys_socketpair(2)            */
.equ SYS_SEND,        9               /* sys_send(2)                  */
.equ SYS_RECV,        10              /* sys_recv(2)                  */
.equ SYS_SENDTO,      11              /* sys_sendto(2)                */
.equ SYS_RECVFROM,    12              /* sys_recvfrom(2)              */
.equ SYS_SHUTDOWN,    13              /* sys_shutdown(2)              */
.equ SYS_SETSOCKOPT,  14              /* sys_setsockopt(2)            */
.equ SYS_GETSOCKOPT,  15              /* sys_getsockopt(2)            */
.equ SYS_SENDMSG,     16              /* sys_sendmsg(2)               */
.equ SYS_RECVMSG,     17              /* sys_recvmsg(2)               */


.equ AF_UNIX,         1       @ Unix domain sockets
.equ AF_LOCAL,        1       @ POSIX name for AF_UNIX
.equ AF_INET,         2       @ Internet IP Protocol
.equ AF_AX25,         3       @ Amateur Radio AX.25
.equ AF_IPX,          4       @ Novell IPX
.equ AF_APPLETALK,    5       @ AppleTalk DDP
.equ AF_NETROM,       6       @ Amateur Radio NET/ROM
.equ AF_BRIDGE,       7       @ Multiprotocol bridge
.equ AF_ATMPVC,       8       @ ATM PVCs
.equ AF_X25,          9       @ Reserved for X.25 project
.equ AF_INET6,        10      @ IP version 6
.equ AF_ROSE,         11      @ Amateur Radio X.25 PLP
.equ AF_DECnet,       12      @ Reserved for DECnet project
.equ AF_NETBEUI,      13      @ Reserved for 802.2LLC project
.equ AF_SECURITY,     14      @ Security callback pseudo AF
.equ AF_KEY,          15      @ PF_KEY key management API
.equ AF_NETLINK,      16
.equ AF_ROUTE,        AF_NETLINK      @ Alias to emulate 4.4BSD
.equ AF_PACKET,       17      @ Packet family
.equ AF_ASH,          18      @ Ash
.equ AF_ECONET,       19      @ Acorn Econet
.equ AF_ATMSVC,       20      @ ATM SVCs
.equ AF_SNA,          22      @ Linux SNA Project (nutters!)
.equ AF_IRDA,         23      @ IRDA sockets
.equ AF_MAX,          32      @ For now..

.equ PF_UNSPEC,       AF_UNSPEC
.equ PF_UNIX,         AF_UNIX
.equ PF_LOCAL,        AF_LOCAL
.equ PF_INET,         AF_INET
.equ PF_AX25,         AF_AX25
.equ PF_IPX,          AF_IPX
.equ PF_APPLETALK,    AF_APPLETALK
.equ PF_NETROM,       AF_NETROM
.equ PF_BRIDGE,       AF_BRIDGE
.equ PF_ATMPVC,       AF_ATMPVC
.equ PF_X25,          AF_X25
.equ PF_INET6,        AF_INET6
.equ PF_ROSE,         AF_ROSE
.equ PF_DECnet,       AF_DECnet
.equ PF_NETBEUI,      AF_NETBEUI
.equ PF_SECURITY,     AF_SECURITY
.equ PF_KEY,          AF_KEY
.equ PF_NETLINK,      AF_NETLINK
.equ PF_ROUTE,        AF_ROUTE
.equ PF_PACKET,       AF_PACKET
.equ PF_ASH,          AF_ASH
.equ PF_ECONET,       AF_ECONET
.equ PF_ATMSVC,       AF_ATMSVC
.equ PF_SNA,          AF_SNA
.equ PF_IRDA,         AF_IRDA
.equ PF_MAX,          AF_MAX

.equ SOCK_STREAM,    1        @stream (connection) socket
.equ SOCK_DGRAM,     2        @datagram (conn.less) socket
.equ SOCK_RAW,       3        @raw socket
.equ SOCK_RDM,       4        @reliably-delivered message
.equ SOCK_SEQPACKET, 5        @sequential packet socket
.equ SOCK_PACKET,    10       @linux specific way of getting packets at the dev level

.equ IPPROTO_IP,              0               @ Dummy protocol for TCP
.equ IPPROTO_HOPOPTS,         0               @ IPv6 Hop-by-Hop options
.equ IPPROTO_ICMP,            1               @ Internet Control Message Protocol
.equ IPPROTO_IGMP,            2               @ Internet Group Management Protocol
.equ IPPROTO_IPIP,            4               @ IPIP tunnels (older KA9Q tunnels use 94)
.equ IPPROTO_TCP,             6               @ Transmission Control Protocol
.equ IPPROTO_EGP,             8               @ Exterior Gateway Protocol
.equ IPPROTO_PUP,             12              @ PUP protocol
.equ IPPROTO_UDP,             17              @ User Datagram Protocol
.equ IPPROTO_IDP,             22              @ XNS IDP protocol
.equ IPPROTO_TP,              29              @ SO Transport Protocol Class 4
.equ IPPROTO_IPV6,            41              @ IPv6 header
.equ IPPROTO_ROUTING,         43              @ IPv6 routing header
.equ IPPROTO_FRAGMENT,        44              @ IPv6 fragmentation header
.equ IPPROTO_RSVP,            46              @ Reservation Protocol
.equ IPPROTO_GRE,             47              @ General Routing Encapsulation
.equ IPPROTO_ESP,             50              @ encapsulating security payload
.equ IPPROTO_AH,              51              @ authentication header
.equ IPPROTO_ICMPV6,          58              @ ICMPv6
.equ IPPROTO_NONE,            59              @ IPv6 no next header
.equ IPPROTO_DSTOPTS,         60              @ IPv6 destination options
.equ IPPROTO_MTP,             92              @ Multicast Transport Protocol
.equ IPPROTO_ENCAP,           98              @ Encapsulation Header
.equ IPPROTO_PIM,             103             @ Protocol Independent Multicast
.equ IPPROTO_RAW,             255             @ Raw IP packets

.equ O_RDONLY,		00
.equ O_WRONLY,		01
.equ O_RDWR,		02
.equ O_CREAT,		0100
.equ O_EXCL,		0200
.equ O_NOCTTY,		0400
.equ O_TRUNC,		01000
.equ O_APPEND,		02000
.equ O_NONBLOCK,	04000
.equ O_NDELAY,		O_NONBLOCK
.equ O_SYNC,		010000
.equ O_FSYNC,		O_SYNC
.equ O_ASYNC,		020000

