	.GLOBAL nrv2e_decompress
	.ARM
	.SECTION .text

@----------------------------------------------------------
@ NRV2E decompression routine
@ 
@ proto-->   nrv2e_decompress( *src, src_len, *dst, &dst_len)
@
@-----------------------------------------------------------
nrv2e_decompress:
	stmdb	sp!, { r4-r7, lr }
	add	r7,r1,r0
	stmdb	sp!,{ r2, r3 }
	mov	r4,#0
	mvn	r5,r4
	movs	r1,r5,lsl #1
	b	.l1c
	
.l17:	ldrb	r1,[r0],#1
	strb	r1,[r2],#1	/* equiv to movsb */
.l18:	add     r6,r6,r6	/* add  bl,bl (r6 --> ebx) */
	movs	r1,r6,lsl #24
	bne	.l21
.l1c:	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l21:	bcs	.l17
	mov	r3,#1
.l26:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l2f
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l2f:	adcs	r3,r3,r3
	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l3a
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24

.l3a:	bcs	.l_4a
	sub	r3,r3,#1
	add     r6,r6,r6	/* add  bl,bl (r6 --> ebx) */
	movs	r1,r6,lsl #24
	bne	.l_46
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l_46:	adc	r3,r3,r3
	b	.l26

.l_4a:	subs	r3,r3,#3
	bmi	.l__6b
	ldrb	r1,[r0],#1
	add	r3,r1,r3,lsl #8
	mvns	r3,r3
	beq	.l90
	movs	r3,r3,asr #1
	mov	r5,r3
	bcc	.l__76

.l4c:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l55
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l55:	adcs	r4,r4,r4
	b	.l7e

.l__6b:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__74
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__74:	bcs	.l4c			@ jc	0x5e
.l__76:	adds	r4,r4,#1		@ inc	ecx
.l65:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__80
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__80:	bcs	.l4c			@ jc 	0x5e
.l__82:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__8b
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__8b:	adcs	r4,r4,r4		@ adc	ecx,ecx
	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__96
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__96:	bcc	.l__82
	add	r4,r4,#2
.l7e:	mvn	r1,#1280	@ 0xfffffb00
	cmps	r1,r5
	adc	r4,r4,#2
.movsb:	ldrb	r1,[r2, r5]
	strb	r1,[r2],#1
	subs	r4,r4,#1
	bne	.movsb
	b	.l18
.l90:	cmps	r0,r7
	beq	.la3
	sub	r0,r3,#1
.la3:	mov	r4,r2
	ldmia	sp!,{ r2, r3 }
	sub	r4,r4,r2
	str	r4,[r3]
	ldmia   sp!, {r4-r7, pc}


.END
